import java.awt.Container;
import java.awt.GridLayout;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.JButton;
import javax.swing.JFrame;

public class FenetreBonjour extends JFrame {

	private static final String BONJOUR = "Bonjour !";
	private static final String AU_REVOIR = "Au revoir !";
	private static int DELTA_X = 50;
	private static int DELTA_Y = 50;

	private static int nFrames;

	public FenetreBonjour() {
		super(BONJOUR);
		Container c = getContentPane();
		c.setLayout(new GridLayout(0, 1));
		ajouterBouton(c, BONJOUR, e -> System.out.println(BONJOUR));
		ajouterBouton(c, AU_REVOIR, e -> {
			this.dispose();
			fermer();
		});
		addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
				fermer();
			}
		});
	}

	private void ajouterBouton(Container c, String label, ActionListener listener) {
		JButton bouton = new JButton(label);
		bouton.addActionListener(listener);
		c.add(bouton);
	}

	public void fermer() {
		nFrames--;
		if (nFrames == 0)
			System.exit(0);
	}

	public static void main(String[] args) {
		javax.swing.SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				nFrames = Integer.parseInt(args[0]);
				for (int i = 0; i < nFrames; i++) {
					JFrame f = new FenetreBonjour();
					f.pack();
					f.setLocation(i * DELTA_X, i * DELTA_Y);
					f.setVisible(true);
				}
			}
		});
	}
}
